/*
 C++ 3,4 Test program for the TechScheduler API.

 Requires TKSHDAPI.DLL to be in the Windows or same directory.

 This demo can be used without any restrictions and can be
 modified without prior permission. We request that updates
 and bugs be sent to Winutils@aol.com

 copyright 1998-99 Dean Software Design
 www.winutils.com
*/

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TForm1 *Form1;
HANDLE hDLL;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
hDLL = LoadLibrary("tkshdapi.dll");
if (hDLL){
   pRunScheduler = (RunScheduler)GetProcAddress(hDLL,"RunScheduler");
     if (pRunScheduler == 0) {
        ShowMessage("Address of RunScheduler invalid");
     } else {
       pKillScheduler   = (KillScheduler)GetProcAddress(hDLL,"KillScheduler");
       pPauseScheduler  = (PauseScheduler)GetProcAddress(hDLL,"PauseScheduler");
       pStartScheduler  = (StartScheduler)GetProcAddress(hDLL,"StartScheduler");
       pRunJob          = (RunJob)GetProcAddress(hDLL,"RunJob");
       pPauseJob        = (PauseJob)GetProcAddress(hDLL,"PauseJob");
       pStartJob        = (StartJob)GetProcAddress(hDLL,"StartJob");
       pDeleteJob       = (DeleteJob)GetProcAddress(hDLL,"DeleteJob");
       pSetJobParameter = (SetJobParameter)GetProcAddress(hDLL,"SetJobParameter");
       pGetLastAPIError = (GetLastAPIError)GetProcAddress(hDLL,"GetLastAPIError");
       pReadJobFile     = (ReadJobFile)GetProcAddress(hDLL,"ReadJobFile");
       pSetConfigParameter = (SetConfigParameter)GetProcAddress(hDLL,"SetConfigParameter");
       pWriteLogEntry = (WriteLogEntry)GetProcAddress(hDLL,"WriteLogEntry");
     }
   } else {
   ShowMessage("Unable to load tkshdapi.dll");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
if (hDLL){
   FreeLibrary(hDLL);
}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
   OpenDialog1->FileName = "*.exe";
   if (OpenDialog1->Execute()) {
      Edit1->Text = OpenDialog1->FileName;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   if (Edit1->Text.Length()>0) {
      char* szBuffer = new char[Edit1->Text.Length() + 1];
      StrPCopy(szBuffer, Edit1->Text.c_str());
      if (pRunScheduler(Form1->Handle,szBuffer)==0) {
         ShowMessage("TechScheduler Started");
      } else {
         ShowMessage("TechScheduler Startup Failed");
      }
      delete [] szBuffer;
   } else {
      ShowMessage("No path for TechScheduler entered..");
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
      if (pKillScheduler()==0) {
         ShowMessage("TechScheduler Killed");
      } else {
         ShowMessage("TechScheduler Shutdown Failed");
      }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
   if (Edit2->Text.Length()>0) {
      char* szBuffer = new char[Edit2->Text.Length() + 1];
      StrPCopy(szBuffer, Edit2->Text.c_str());
      if (pRunJob(szBuffer)==0) {
         ShowMessage("Job Started");
      } else {
         ShowMessage("Job not Started");
      }
      delete [] szBuffer;
   } else {
      ShowMessage("No jobname entered..");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
   if (pPauseScheduler()==0) {
      ShowMessage("TechScheduler Paused");
   }
   else
   {
      ShowMessage("TechScheduler Pause Failed");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
   if (pStartScheduler()==0) {
      ShowMessage("TechScheduler Restarted");
   }
   else
   {
      ShowMessage("TechScheduler Restart Failed");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
   switch (pGetLastAPIError()) {
      case 0:
         ShowMessage("Last Function Successful");
         break;
// you could put all the different return codes too...
      default:
         ShowMessage("Last Function Failed");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
   if (Edit2->Text.Length()>0) {
      char* szBuffer = new char[Edit2->Text.Length() + 1];
      StrPCopy(szBuffer, Edit2->Text.c_str());
      if (pPauseJob(szBuffer)==0) {
         ShowMessage("Job Paused");
      } else {
         ShowMessage("Job not Paused");
      }
      delete [] szBuffer;
   } else {
      ShowMessage("No jobname entered..");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
   if (Edit2->Text.Length()>0) {
      char* szBuffer = new char[Edit2->Text.Length() + 1];
      StrPCopy(szBuffer, Edit2->Text.c_str());
      if (pStartJob(szBuffer)==0) {
         ShowMessage("Job Restarted");
      } else {
         ShowMessage("Job not Restarted");
      }
      delete [] szBuffer;
   } else {
      ShowMessage("No jobname entered..");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button9Click(TObject *Sender)
{
   if (Edit2->Text.Length()>0) {
      char* szBuffer = new char[Edit2->Text.Length() + 1];
      StrPCopy(szBuffer, Edit2->Text.c_str());
      if (pDeleteJob(szBuffer)==0) {
         ShowMessage("Job Deleted");
      } else {
         ShowMessage("Job not Deleted");
      }
      delete [] szBuffer;
   } else {
      ShowMessage("No jobname entered..");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button10Click(TObject *Sender)
{
   if (Edit3->Text.Length()>0) {
      char* szBuffer = new char[Edit3->Text.Length() + 1];
      StrPCopy(szBuffer, Edit3->Text.c_str());
      if (pPauseJob(szBuffer)==0) {
         ShowMessage("JobFile Name Submitted");
      } else {
         ShowMessage("JobFile Name not Submitted");
      }
      delete [] szBuffer;
   } else {
      ShowMessage("No jobfile name entered..");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button11Click(TObject *Sender)
{
   if (Edit2->Text.Length()>0) {
      char* szJob = new char[Edit2->Text.Length() + 1];
      char* szParam = new char[Edit4->Text.Length() + 1];
      char* szStr = new char[Edit5->Text.Length() + 1];
      bool bBool;
      int iInt;
      StrPCopy(szJob, Edit2->Text.c_str());
      StrPCopy(szParam, Edit4->Text.c_str());
      StrPCopy(szStr, Edit5->Text.c_str());
      iInt = CSpinEdit1->Value;
      switch (RadioGroup1->ItemIndex){
        case 0:bBool=true;
               break;
        case 1:bBool=false;
               break;
      }
      if (pSetJobParameter(szJob,szParam,szStr,iInt,bBool)==0) {
         ShowMessage("Job Parameter Set");
      } else {
         ShowMessage("Job Parameter not Set");
      }
      delete [] szJob;
      delete [] szParam;
      delete [] szStr;
   } else {
      ShowMessage("No jobname entered..");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button12Click(TObject *Sender)
{
   char* szParam = new char[Edit4->Text.Length() + 1];
   char* szStr = new char[Edit5->Text.Length() + 1];
   bool bBool;
   int iInt;
   StrPCopy(szParam, Edit4->Text.c_str());
   StrPCopy(szStr, Edit5->Text.c_str());
   iInt = CSpinEdit1->Value;
   switch (RadioGroup1->ItemIndex){
     case 0:bBool=true;
            break;
     case 1:bBool=false;
            break;
   }
   if (pSetConfigParameter(szParam,szStr,iInt,bBool)==0) {
      ShowMessage("Config Parameter Set");
   } else {
      ShowMessage("Config Parameter not Set");
   }
   delete [] szParam;
   delete [] szStr;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button13Click(TObject *Sender)
{
      char* szJob = new char[Edit2->Text.Length() + 1];
      char* szStr = new char[Edit5->Text.Length() + 1];
      StrPCopy(szJob, Edit2->Text.c_str());
      StrPCopy(szStr, Edit5->Text.c_str());
      if (pWriteLogEntry(szJob,szStr)==0) {
         ShowMessage("Log Entry Written");
      } else {
         ShowMessage("Log Entry not Written");
      }
      delete [] szJob;
      delete [] szStr;
}
//---------------------------------------------------------------------------

