/*
 C++ 3,4 Test program for the TechScheduler API.

 Requires TKSHDAPI.DLL to be in the Windows or same directory.

 This demo can be used without any restrictions and can be
 modified without prior permission. We request that updates
 and bugs be sent to Winutils@aol.com

 copyright 1998-99 Dean Software Design
 www.winutils.com
*/

//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Sharemem.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "CSPIN.h"
#include <Buttons.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>

// Define all the exported DLL functions
typedef _stdcall int(*RunScheduler)(HWND CallerHWnd, char* Path);
typedef _stdcall int(*KillScheduler)();
typedef _stdcall int(*PauseScheduler)();
typedef _stdcall int(*StartScheduler)();
typedef _stdcall int(*RunJob)(char* jobname);
typedef _stdcall int(*PauseJob)(char* jobname);
typedef _stdcall int(*StartJob)(char* jobname);
typedef _stdcall int(*DeleteJob)(char* jobname);
typedef _stdcall int(*SetJobParameter)(char* jobname, char* paramid,
                         char* strdata, int intdata,
                         bool booldata);
typedef _stdcall int(*GetLastAPIError)();
typedef _stdcall int(*ReadJobFile)(char* jobfilename);
typedef _stdcall int(*SetConfigParameter)(char* paramid,
                         char* strdata, int intdata,
                         bool booldata);
typedef _stdcall int(*WriteLogEntry)(char* jobname,
                         char* logdata);

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TLabel *Label1;
        TSpeedButton *SpeedButton1;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        TLabel *Label6;
        TLabel *Label7;
        TButton *Button1;
        TButton *Button2;
        TEdit *Edit1;
        TButton *Button3;
        TButton *Button4;
        TButton *Button5;
        TEdit *Edit2;
        TButton *Button6;
        TButton *Button7;
        TButton *Button8;
        TButton *Button9;
        TButton *Button10;
        TButton *Button11;
        TEdit *Edit3;
        TEdit *Edit4;
        TEdit *Edit5;
        TRadioGroup *RadioGroup1;
        TButton *Button12;
        TOpenDialog *OpenDialog1;
        TCSpinEdit *CSpinEdit1;
        TButton *Button13;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall SpeedButton1Click(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall Button6Click(TObject *Sender);
        void __fastcall Button3Click(TObject *Sender);
        void __fastcall Button4Click(TObject *Sender);
        void __fastcall Button5Click(TObject *Sender);
        void __fastcall Button7Click(TObject *Sender);
        void __fastcall Button8Click(TObject *Sender);
        void __fastcall Button9Click(TObject *Sender);
        void __fastcall Button10Click(TObject *Sender);
        void __fastcall Button11Click(TObject *Sender);
        void __fastcall Button12Click(TObject *Sender);
        void __fastcall Button13Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;

RunScheduler pRunScheduler=0;
KillScheduler pKillScheduler=0;
PauseScheduler pPauseScheduler=0;
StartScheduler pStartScheduler=0;
RunJob pRunJob=0;
PauseJob pPauseJob=0;
StartJob pStartJob=0;
DeleteJob pDeleteJob=0;
SetJobParameter pSetJobParameter=0;
GetLastAPIError pGetLastAPIError=0;
ReadJobFile pReadJobFile=0;
SetConfigParameter pSetConfigParameter=0;
WriteLogEntry pWriteLogEntry=0;

//---------------------------------------------------------------------------
#endif
